#include <tiny13a.h>

// Watchdog timeout interrupt service routine
interrupt [WDT] void wdt_timeout_isr(void)
{
 static unsigned char temp=1;
       PORTB=temp;      
       if(temp>2)temp=1;
          else temp=(temp<<1);
}

void main(void)
{
 // Input/Output Ports initialization
 PORTB=0x00;
 DDRB=(1<<DDB5)|(1<<DDB4)|(1<<DDB3)|(1<<DDB2)|(1<<DDB1)|(1<<DDB0);

 // Digital input buffers on ADC0: Off, ADC1: Off, ADC2: Off, ADC3: Off
 DIDR0  = (1<<ADC0D) |  (1<<ADC2D)|  (1<<ADC3D) | (1<<ADC1D) | (1<<AIN1D) | (1<<AIN0D);

 // Timer/Counter 0 initialization
 TCCR0A=0x00;
 TCCR0B=0x00;
 TCNT0=0x00;
 OCR0A=0x00;
 OCR0B=0x00;
 
 // Timer/Counter 0 Interrupt(s) initialization
 TIMSK0=0x00;

 // External Interrupts initialization
 GIMSK=0x00;

 MCUCR=(1<<SM1); // Power down for "SLEEP"

 // Analog Comparator: Off
 ACSR=(1<<ACD);
 ADCSRB=0x00;
 ADCSRA=0x00; // ADC :Stop

 PRR=(1<<PRTIM0)|(1<<PRADC); // Timer, ADC -power off

 // Clear WDRF in MCUSR 
 MCUSR=0x00;
 #asm("wdr")
 // Watchdog Timer Prescaler: OSC/32k
 // Watchdog Timer interrupt: On
#pragma optsize-
 WDTCR=(1<<WDCE);
 WDTCR=(1<<WDTIE)|(1<<WDP2); 
 WDTCR|=(1<<WDTIF); 
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

 // SLEEP enable
 MCUCR|=(1<<SE);

 // Global enable interrupts
 #asm("sei")

 while (1) #asm("sleep")

}
